#!/usr/bin/env python

import os, time, sys

execfile("p11RB-teams.py")

scoreboard = "/var/www/html/index.html"
tempscoreboard = "/tmp/scoreboard.html"
interval = 10

verbose = 1
redmult = 20


if verbose > 1:
  print teams
  print ips

def readpts(filename):
  global verbose
  if verbose > 1:
    print "   Entering readpts(", filename, ")",
  try:
    with open(filename) as f:
      if verbose > 1:
        print "File", filename, "found",
      s = f.readlines()
      ss = s[0].strip()
      newpts = int(ss)
      if verbose > 1:
        print "Points ", newpts, "found in file", filename
  except:
    if verbose > 1:
      print "No old points found in file", filename
    newpts = 0
  return newpts

def readstr(filename):
  global verbose
  if verbose > 1:
    print "   Entering readstr(", filename, ")",
  try:
    with open(filename, "r") as f:
      s = f.readlines()
      print "S: ", s
      if verbose > 1:
        print "File", filename, "found",
      ss = s[0].strip()
      if verbose > 1:
        print "String ", ss, "found in file", filename
  except:
    if verbose > 1:
      print "No string found in file", filename
    ss = ""
  return ss


bonus_pts_prefix = "/tmp/bonus_pts_"
bonus_log_prefix = "/tmp/bonus_log_"




c = raw_input("Clear old scores (y, n): ")
if c == "y":
  print "Clearing old scores"
  cmd = "rm /tmp/blue* /tmp/red*"
  os.system(cmd)

t_start = time.time()

nteams = len(teams)
tmpfile = "/tmp/pts"

while True:
  t0 = time.time()
  sys.stdout.write("Time: " + str(round(t0 - t_start, 2)))

  cmd = "echo '<html><head>' > " +tempscoreboard
  os.system(cmd)
  cmd = "echo '<meta http-equiv=\"refresh\" content=\"10\">' >> " +tempscoreboard
  os.system(cmd)
  cmd = "echo '</head><body bgcolor=\"#cccccc\" style=\"font-family:Arial\">' >> " +tempscoreboard
  os.system(cmd)
  cmd = "echo '<h1 align=\"center\">SCORES</h1>' >> " +tempscoreboard
  os.system(cmd)
  cmd = "echo '<table align=\"center\" border=10 cellpadding=10>' >> " +tempscoreboard
  os.system(cmd)

  for i in range(nteams):
    team = teams[i]
    ip = ips [i]
    if verbose > 1:
      print "Scoring team", team, ip

    # GET OLD POINTS
    blueteamfile = "/tmp/blue_" + team
    bluepts = readpts(blueteamfile)
    redteamfile = "/tmp/red_" + team
    redpts = readpts(redteamfile)

    # Clear reasons
    bluereason = ""
    redreason = ""

    # GET BONUS POINTS
    bonus_pts_file = bonus_pts_prefix + "_blue_" + team
    bluepts += readpts(bonus_pts_file)
    cmd = "echo 0 > " + bonus_pts_file
    os.system(cmd)
    
    bonus_pts_file = bonus_pts_prefix + "_red_" + team
    redpts += readpts(bonus_pts_file)
    cmd = "echo 0 > " + bonus_pts_file
    os.system(cmd)
 
    bonus_log_file = bonus_log_prefix + "_blue_" + team
    bonus_log_blue = readstr(bonus_log_file)
    if verbose > 0:
      print "*** BLUE BONUS LOG:", bonus_log_blue, "from file", bonus_log_file
    bonus_log_file  = bonus_log_prefix + "_red_" + team
    bonus_log_red = readstr(bonus_log_file)

    
    # PING TEST
    cmd = "ping -c2 -i0.5 -w1 " + ip + "| grep \"bytes from\" | wc -l > " + tmpfile
    if verbose > 1:
      print "Command: ", cmd
    os.system(cmd)

    newpts = readpts(tmpfile)
    if newpts > 0:
      bluepts += newpts
      bluereason += "<font color=#009900><b>PING</b></font> "
    else:
      # redpts += 1
      # redreason += "PING_FAIL "
      bluereason += "<font color=#990000><b>PING</b></font> "
    if verbose > 1:
      print "New points", newpts, "BLUE:", bluepts, "RED:", redpts


    # WEB PAGE TEST
    cmd = "curl -m 1 -s " + ip + " | grep \"City College\" | wc -l > " + tmpfile
    if verbose > 1:
      print "Command: ", cmd
    os.system(cmd)

    newpts = readpts(tmpfile)
    if newpts > 0:
      bluepts += newpts
      bluereason += "<font color=#009900><b>WEB</b></font> "
    else:
      # redpts += 1
      # redreason += "WEB_FAIL "
      bluereason += "<font color=#990000><b>WEB</b></font> "
    if verbose > 1:
      print "New points", newpts, "BLUE:", bluepts, "RED:", redpts


    # SPLUNK PAGE TEST
    cmd = "curl -m 1 -s " + ip + ":8000 | grep 'en-US' | wc -c > " + tmpfile
    if verbose > 1:
      print "Command: ", cmd
    os.system(cmd)

    newpts = readpts(tmpfile)
    if newpts > 0:
      bluepts += 8
      bluereason += "<font color=#009900><b>SPLUNK</b></font> "
    else:
      # redpts += 1
      # redreason += "WEB_FAIL "
      bluereason += "<font color=#990000><b>SPLUNK</b></font> "
    if verbose > 1:
      print "New points", newpts, "BLUE:", bluepts, "RED:", redpts



    # PWNED1 PAGE TEST
    cmd = "curl -m 1 -s " + ip + "/pwned1.htm | grep 'HINT' | wc -c > " + tmpfile
    if verbose > 1:
      print "Command: ", cmd
    os.system(cmd)

    pwnlen = readpts(tmpfile)
    if pwnlen > 15:
      redpts += redmult
      redreason += "PWNED1 "
    if verbose > 1:
      print "New points", newpts, "BLUE:", bluepts, "RED:", redpts



    # PWNED2 PAGE TEST
    cmd = "curl -m 1 -s " + ip + "/pwned2.htm | grep 'HINT' | wc -c > " + tmpfile
    if verbose > 1:
      print "Command: ", cmd
    os.system(cmd)

    pwnlen = readpts(tmpfile)
    if pwnlen > 15:
      redpts += redmult
      redreason += "PWNED2 "
    if verbose > 1:
      print "New points", newpts, "BLUE:", bluepts, "RED:", redpts



    # PWNED3 PAGE TEST
    cmd = "curl -m 1 -s " + ip + "/pwned3.htm | grep 'HINT' | wc -c > " + tmpfile
    if verbose > 1:
      print "Command: ", cmd
    os.system(cmd)

    pwnlen = readpts(tmpfile)
    if pwnlen > 15:
      redpts += redmult
      redreason += "PWNED3 "
    if verbose > 1:
      print "New points", newpts, "BLUE:", bluepts, "RED:", redpts




    # WRITE OUT NEW POINT TOTALS
    cmd = "echo " + str(bluepts) + " > " + blueteamfile
    os.system(cmd)
    cmd = "echo " + str(redpts) + " > " + redteamfile
    os.system(cmd)

    # UPDATE tempscoreboard
    
    cmd = "echo '<tr><td align=\"center\" bgcolor=\"lightgreen\"><big><b>' >> " + tempscoreboard
    os.system(cmd)
    cmd = "echo '" + team + "</b></big><br>" + ip + "</td>' >> " + tempscoreboard
    os.system(cmd)

    cmd = "echo '<td align=\"center\" bgcolor=\"lightblue\"><big><b>' >> " + tempscoreboard
    os.system(cmd)
    cmd = "echo '" + str(bluepts) + "</big></b><br>" + bluereason + "' >> " + tempscoreboard
    os.system(cmd)
    cmd = "echo '<br>" + bonus_log_blue + "</td>' >> " + tempscoreboard
    os.system(cmd)

    cmd = "echo '<td align=\"center\" bgcolor=\"#ffcccc\"><big><b>' >> " + tempscoreboard
    os.system(cmd)
    cmd = "echo '" + str(redpts) + "</big></b><br>" + redreason + "' >> " + tempscoreboard
    os.system(cmd)
    cmd = "echo '<br>" + bonus_log_red + "</td>' >> " + tempscoreboard
    os.system(cmd)

    # cmd = "echo 'RED : " + str(redpts) + "</big></b><br>" + redreason + "</td>' >> " + tempscoreboard
    # os.system(cmd)

    cmd = "echo '</td></tr>' >> " + tempscoreboard
    os.system(cmd)

    if verbose > 0:
      sys.stdout.write("\n\t" + team + " Red:" + str(redpts) + " " + redreason + "\tBlue:" + str(bluepts) + " " + bluereason)
      sys.stdout.flush()

  cmd = "echo '</table><p>' >> " +tempscoreboard
  os.system(cmd)
  cmd = "echo 'Page will not automatically refresh in Firefox<p>' >> " +tempscoreboard
  os.system(cmd)
  cmd = "echo 'Updated:' >> " +tempscoreboard
  os.system(cmd)
  cmd = "date >> " +tempscoreboard
  os.system(cmd)
  cmd = "echo '<p></body></html>' >> " +tempscoreboard
  os.system(cmd)

  cmd = "mv " + tempscoreboard + " " + scoreboard
  os.system(cmd)


  print "\tSLEEPING ",
  while (time.time() - t0) < interval:
    time.sleep(1)
    sys.stdout.write(".")
    sys.stdout.flush()
  print
